#line 286 "nws/complement.nw"
#ifndef _NKLEIN_COMPLEMENT_H_
#define _NKLEIN_COMPLEMENT_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 262 "nws/complement.nw"
class complement : public object {
protected:
    
#line 35 "nws/complement.nw"
object* obj;
#line 265 "nws/complement.nw"
public:
    
#line 45 "nws/complement.nw"
complement( const scene* ss );
#line 59 "nws/complement.nw"
virtual ~complement( void );
#line 73 "nws/complement.nw"
virtual void setDimensions( unsigned int dd );
#line 93 "nws/complement.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 148 "nws/complement.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 186 "nws/complement.nw"
virtual bool inside( const mathvec< double >& start ) const;
virtual bool _inside( const mathvec< double >& rp ) const;
#line 218 "nws/complement.nw"
friend std::istream& operator >> ( std::istream& in, complement& cc );
#line 267 "nws/complement.nw"
public:
    static const char* id;
};

#line 296 "nws/complement.nw"
#endif /*_NKLEIN_COMPLEMENT_H_*/
