#line 582 "nws/convex.nw"
#ifndef _NKLEIN_CONVEX_H_
#define _NKLEIN_CONVEX_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 556 "nws/convex.nw"
class convex : public csginter {
private:
    
#line 48 "nws/convex.nw"
std::vector< mathvec< double > > pts;
#line 559 "nws/convex.nw"
protected:
    
#line 52 "nws/convex.nw"
double colorDistance;
std::vector< color* > specialColors;
#line 561 "nws/convex.nw"
public:
    
#line 60 "nws/convex.nw"
convex( const scene* ss );
#line 73 "nws/convex.nw"
virtual ~convex( void );
#line 84 "nws/convex.nw"
void addPoint( const mathvec< double >& point );
#line 103 "nws/convex.nw"
void calculateBoundingPlanes( bool dbg = false );
#line 363 "nws/convex.nw"
bool incrementChoice( mathvec< unsigned int >& choice, unsigned int nn );
#line 393 "nws/convex.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 455 "nws/convex.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 489 "nws/convex.nw"
friend std::istream& operator >> ( std::istream& in, convex& cc );
#line 563 "nws/convex.nw"
public:
    static const char* id;
};

#line 592 "nws/convex.nw"
#endif /*_NKLEIN_CONVEX_H_*/
