#line 331 "nws/extrusion.nw"
#ifndef _NKLEIN_EXTRUSION_H_
#define _NKLEIN_EXTRUSION_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 307 "nws/extrusion.nw"
class extrusion : public object {
protected:
    
#line 35 "nws/extrusion.nw"
unsigned int subDimensions;
object* obj;
#line 310 "nws/extrusion.nw"
public:
    
#line 46 "nws/extrusion.nw"
extrusion( const scene* ss );
#line 60 "nws/extrusion.nw"
virtual ~extrusion( void );
#line 74 "nws/extrusion.nw"
virtual void setDimensions( unsigned int dd );
#line 97 "nws/extrusion.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 182 "nws/extrusion.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 227 "nws/extrusion.nw"
virtual bool inside( const mathvec< double >& start ) const;
virtual bool _inside( const mathvec< double >& rp ) const;
#line 261 "nws/extrusion.nw"
friend std::istream& operator >> ( std::istream& in, extrusion& cc );
#line 312 "nws/extrusion.nw"
public:
    static const char* id;
};

#line 341 "nws/extrusion.nw"
#endif /*_NKLEIN_EXTRUSION_H_*/
