#line 115 "nws/main.nw"
#include <fstream>
#include <iostream>
#include <sstream>
#include "scene.h"
#include "nkthread.h"

#line 10 "nws/main.nw"
int
main( int argc, const char* const argv[] )
{
    int ii;

    
#line 34 "nws/main.nw"
for ( ii=1; ii < argc; ++ii ) {
    std::string arg( argv[ ii ] );

    if ( arg[0] != '-' ) {
	break;
    } else if ( arg == "-t" ) {
	
#line 53 "nws/main.nw"
std::istringstream str( argv[++ii] );
unsigned int count = 0;
str >> count;
if ( count > 100 ) {
    count = 100;
}
thread::instance()->setWorkerCount( count );
#line 41 "nws/main.nw"
    } else {
	std::cerr << "Unknown argument: " << arg << std::endl;
	
#line 65 "nws/main.nw"
std::cerr << "USAGE: " << argv[0];
std::cerr << " [-t threadCount]";
std::cerr << " file1 file2 ..." << std::endl;
#line 44 "nws/main.nw"
	return __LINE__;
    }
}

#line 17 "nws/main.nw"
    if ( ii < argc ) {
	
#line 76 "nws/main.nw"
while ( ii < argc ) {
    std::ifstream stream( argv[ii++] );
    if ( stream.good() ) {
	scene ss;
	stream >> ss;
	ss.render();
    } else {
	std::cerr << "Couldn't open: " << argv[ii-1] << std::endl;
    }
}
#line 19 "nws/main.nw"
    } else {
	
#line 92 "nws/main.nw"
if ( std::cin.good() ) {
    scene ss;
    std::cin >> ss;
    ss.render();
} else {
    std::cerr << "Couldn't read standard input" << std::endl;
}
#line 21 "nws/main.nw"
    }

    return 0;
}
