#line 395 "nws/quadratic.nw"
#ifndef _NKLEIN_QUADRATIC_H_
#define _NKLEIN_QUADRATIC_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 371 "nws/quadratic.nw"
class quadratic : public object {
protected:
    
#line 36 "nws/quadratic.nw"
basevec< mathvec< double > > squares;
mathvec< double > linears;
double scalar;
#line 374 "nws/quadratic.nw"
public:
    
#line 45 "nws/quadratic.nw"
quadratic( const scene* ss );
#line 58 "nws/quadratic.nw"
virtual ~quadratic( void );
#line 71 "nws/quadratic.nw"
virtual void setDimensions( unsigned int dd );
#line 94 "nws/quadratic.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 230 "nws/quadratic.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 285 "nws/quadratic.nw"
virtual bool inside( const mathvec< double >& start ) const;
virtual bool _inside( const mathvec< double >& rp ) const;
#line 322 "nws/quadratic.nw"
friend std::istream& operator >> ( std::istream& in, quadratic& cc );
#line 376 "nws/quadratic.nw"
public:
    static const char* id;
};

#line 405 "nws/quadratic.nw"
#endif /*_NKLEIN_QUADRATIC_H_*/
