#line 325 "nws/csg-set.nw"
#ifndef _NKLEIN_SET_H_
#define _NKLEIN_SET_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 301 "nws/csg-set.nw"
class csgset : public object {
protected:
    
#line 33 "nws/csg-set.nw"
std::vector< object* > objs;
#line 304 "nws/csg-set.nw"
public:
    
#line 40 "nws/csg-set.nw"
csgset( const scene* ss );
#line 53 "nws/csg-set.nw"
virtual ~csgset( void );
#line 70 "nws/csg-set.nw"
virtual void setDimensions( unsigned int dd );
#line 91 "nws/csg-set.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 123 "nws/csg-set.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 225 "nws/csg-set.nw"
virtual bool inside( const mathvec< double >& start ) const;
virtual bool _inside( const mathvec< double >& rp ) const;
#line 258 "nws/csg-set.nw"
friend std::istream& operator >> ( std::istream& in, csgset& cc );
#line 306 "nws/csg-set.nw"
public:
    static const char* id;
};

#line 335 "nws/csg-set.nw"
#endif /*_NKLEIN_SET_H_*/
