#line 337 "nws/halfspace.nw"
#ifndef _NKLEIN_HALFSPACE_H_
#define _NKLEIN_HALFSPACE_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 315 "nws/halfspace.nw"
class halfspace : public object {
public:
    
#line 35 "nws/halfspace.nw"
halfspace( const scene* ss );
#line 47 "nws/halfspace.nw"
halfspace( const mathvec< double >& cc );
#line 63 "nws/halfspace.nw"
halfspace( const mathvec< double >& cc, const mathvec< double >& nn );
#line 83 "nws/halfspace.nw"
virtual ~halfspace( void );
#line 95 "nws/halfspace.nw"
virtual void setDimensions( unsigned int dd );
#line 112 "nws/halfspace.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 195 "nws/halfspace.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 231 "nws/halfspace.nw"
double distance(
    const mathvec< double >& start
) const;
#line 251 "nws/halfspace.nw"
virtual bool inside( const mathvec< double >& start ) const;
virtual bool _inside( const mathvec< double >& rp ) const;
#line 278 "nws/halfspace.nw"
friend std::istream& operator >> ( std::istream& in, halfspace& cc );
#line 318 "nws/halfspace.nw"
public:
    static const char* id;
};

#line 347 "nws/halfspace.nw"
#endif /*_NKLEIN_HALFSPACE_H_*/
