#line 445 "nws/csg-union.nw"
#ifndef _NKLEIN_UNION_H_
#define _NKLEIN_UNION_H_ 1

#include <iostream>
#include <string>
#include <map>
#include "object.h"

    
#line 421 "nws/csg-union.nw"
class csgunion : public object {
protected:
    
#line 33 "nws/csg-union.nw"
std::vector< object* > objs;
#line 424 "nws/csg-union.nw"
public:
    
#line 40 "nws/csg-union.nw"
csgunion( const scene* ss );
#line 53 "nws/csg-union.nw"
virtual ~csgunion( void );
#line 70 "nws/csg-union.nw"
virtual void setDimensions( unsigned int dd );
#line 91 "nws/csg-union.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    intersection& hit
) const;
#line 123 "nws/csg-union.nw"
virtual bool intersect(
    const mathvec< double >& direction,
    const mathvec< double >& start,
    std::vector< intersection* >& hits
) const;
#line 345 "nws/csg-union.nw"
virtual bool inside( const mathvec< double >& start ) const;
virtual bool _inside( const mathvec< double >& rp ) const;
#line 378 "nws/csg-union.nw"
friend std::istream& operator >> ( std::istream& in, csgunion& cc );
#line 426 "nws/csg-union.nw"
public:
    static const char* id;
};

#line 455 "nws/csg-union.nw"
#endif /*_NKLEIN_UNION_H_*/
